C++在线运行

版本:
运行结果
教程手册
代码仓库
极速运行
交互输入
极速运行模式,更高效的运行,点击编辑器上方的运行按钮即刻体验吧。
以下是用户最新保存的代码
随便玩玩啊 发布于:2022-05-25 13:01 OpenJudge1.12_10素数对 发布于:2022-05-22 20:24 OpenJudge1.12_2短信计费 发布于:2022-05-22 19:54 Hello world 发布于:2022-05-20 19:17 用冒泡法对一组用户输入的整数进行排序 发布于:2022-05-19 10:29 regex的应用 发布于:2022-05-18 10:04 C++ learning notebook 发布于:2022-05-17 20:16 测试友元与继承 发布于:2022-05-16 11:28 计算几何模板 发布于:2022-05-15 09:50 c++测试代码 发布于:2022-05-14 21:24 使用stack开发的计算器 发布于:2022-05-12 00:10 图图UDN 发布于:2022-05-11 12:13 Openjudge1.7_18验证子串 发布于:2022-05-09 14:34 Openjudge1.7_5(最标准)但不对qwq 发布于:2022-05-09 13:35 比较字符串相似度? 发布于:2022-05-09 10:30 比较字符串相似度 发布于:2022-05-10 21:48 字符串提取并不能 发布于:2022-05-07 16:37 一个失败的 Linklist 发布于:2022-05-06 09:36 排序+双指针 解决 排除一个数组中存在的另一个数组元素 发布于:2022-05-05 08:40 试题__工厂机器__错误答案 发布于:2022-05-04 16:03 试题__兔子与胡萝卜 发布于:2022-05-04 15:18 试题__等腰三角形 发布于:2022-05-04 14:31 操作系统存储器管理 发布于:2022-05-03 20:50 使用智能指针取代普通指针不需要记得谁开辟的空间谁就要记得释放2 发布于:2022-05-03 09:02 待定需修改 发布于:2022-05-02 11:29 this指针的用法 发布于:2022-05-01 08:52 熟悉指向指针的指针作参数的函数调用 发布于:2022-04-30 11:07 插入排序:: 直接插入,二分插入,希尔插入 发布于:2022-04-29 16:57 选择排序:: 简单选择、堆排序 发布于:2022-04-29 16:32 二叉树常用操作 发布于:2022-04-29 15:32 l两点的间距离计算 发布于:2022-04-29 13:25 用指针常量优化交换两数的代码,更加安全 发布于:2022-04-29 11:25 熟悉指针:判断指针和数组的区别 发布于:2022-04-29 10:10 熟悉指针:要求a >= b >= c的用指针写的代码 发布于:2022-04-29 09:55 操作系统实验二:动态高优先权优先调度算法 发布于:2022-04-28 23:31 求两点间的距离 发布于:2022-04-29 00:09 快排算法代码 发布于:2022-04-28 14:18 循环输出字符 发布于:2022-04-27 23:33 反转字符串 发布于:2022-04-27 21:40 操作系统中的银行家算法 发布于:2022-04-27 17:53 7.宝藏女孩的美食 发布于:2022-04-27 11:29 语句块的分割运用 发布于:2022-04-26 18:25 求函数: x (x<1) y= 2x-1 (1<=x<10) 3x-11 (x>=10) 发布于:2022-04-26 16:49 简单并查集 发布于:2022-04-26 12:58 交换排序::快速排序,冒泡排序 发布于:2022-04-29 16:38 归并排序算法 发布于:2022-04-26 11:13 数组又大到小 发布于:2022-04-25 19:26 地堡承伤计算 发布于:2022-04-25 11:34 kmp算法 发布于:2022-04-24 22:41 dijkstra算法 发布于:2022-04-24 19:53 [更多]
显示目录

异常处理



C++ 异常处理

异常是程序在执行期间产生的问题。C++ 异常是指在程序运行时发生的特殊情况,比如尝试除以零的操作。

异常提供了一种转移程序控制权的方式。C++ 异常处理涉及到三个关键字:try、catch、throw

  • throw: 当问题出现时,程序会抛出一个异常。这是通过使用 throw 关键字来完成的。
  • catch: 在您想要处理问题的地方,通过异常处理程序捕获异常。catch 关键字用于捕获异常。
  • try: try 块中的代码标识将被激活的特定异常。它后面通常跟着一个或多个 catch 块。

如果有一个块抛出一个异常,捕获异常的方法会使用 trycatch 关键字。try 块中放置可能抛出异常的代码,try 块中的代码被称为保护代码。使用 try/catch 语句的语法如下所示:

try
{
   // 保护代码
}catch( ExceptionName e1 )
{
   // catch 块
}catch( ExceptionName e2 )
{
   // catch 块
}catch( ExceptionName eN )
{
   // catch 块
}

如果 try 块在不同的情境下会抛出不同的异常,这个时候可以尝试罗列多个 catch 语句,用于捕获不同类型的异常。

抛出异常

您可以使用 throw 语句在代码块中的任何地方抛出异常。throw 语句的操作数可以是任意的表达式,表达式的结果的类型决定了抛出的异常的类型。

以下是尝试除以零时抛出异常的实例:

double division(int a, int b)
{
   if( b == 0 )
   {
      throw "Division by zero condition!";
   }
   return (a/b);
}

捕获异常

catch 块跟在 try 块后面,用于捕获异常。您可以指定想要捕捉的异常类型,这是由 catch 关键字后的括号内的异常声明决定的。

try
{
   // 保护代码
}catch( ExceptionName e )
{
  // 处理 ExceptionName 异常的代码
}

上面的代码会捕获一个类型为 ExceptionName 的异常。如果您想让 catch 块能够处理 try 块抛出的任何类型的异常,则必须在异常声明的括号内使用省略号 ...,如下所示:

try
{
   // 保护代码
}catch(...)
{
  // 能处理任何异常的代码
}

下面是一个实例,抛出一个除以零的异常,并在 catch 块中捕获该异常。

#include <iostream>
using namespace std;

double division(int a, int b) {
   if( b == 0 )
   {
      throw "Division by zero condition!";
   }
   return (a/b);
}

int main () {
   int x = 50;
   int y = 0;
   double z = 0;

   try {
     z = division(x, y);
     cout << z << endl;
   }catch (const char* msg) {
     cerr << msg << endl;
   }

   return 0;
}

由于我们抛出了一个类型为 const char* 的异常,因此,当捕获该异常时,我们必须在 catch 块中使用 const char*。当上面的代码被编译和执行时,它会产生下列结果:

Division by zero condition!

C++ 标准的异常

C++ 提供了一系列标准的异常,定义在 <exception> 中,我们可以在程序中使用这些标准的异常。它们是以父子类层次结构组织起来的,如下所示:

C++ 异常的层次结构

下表是对上面层次结构中出现的每个异常的说明:

异常 描述
std::exception 该异常是所有标准 C++ 异常的父类。
std::bad_alloc 该异常可以通过 new 抛出。
std::bad_cast 该异常可以通过 dynamic_cast 抛出。
std::bad_exception 这在处理 C++ 程序中无法预期的异常时非常有用。
std::bad_typeid 该异常可以通过 typeid 抛出。
std::logic_error 理论上可以通过读取代码来检测到的异常。
std::domain_error 当使用了一个无效的数学域时,会抛出该异常。
std::invalid_argument 当使用了无效的参数时,会抛出该异常。
std::length_error 当创建了太长的 std::string 时,会抛出该异常。
std::out_of_range 该异常可以通过方法抛出,例如 std::vector 和 std::bitset<>::operator
std::runtime_error 理论上不可以通过读取代码来检测到的异常。
std::overflow_error 当发生数学上溢时,会抛出该异常。
std::range_error 当尝试存储超出范围的值时,会抛出该异常。
std::underflow_error 当发生数学下溢时,会抛出该异常。

定义新的异常

您可以通过继承和重载 exception 类来定义新的异常。下面的实例演示了如何使用 std::exception 类来实现自己的异常:

#include <iostream>
#include <exception>
using namespace std;

struct MyException : public exception
{
  const char * what () const throw () {
    return "C++ Exception";
  }
};

int main() {
  try
  {
    throw MyException();
  }
  catch(MyException& e)
  {
    std::cout << "MyException caught" << std::endl;
    std::cout << e.what() << std::endl;
  }
  catch(std::exception& e)
  {
    //其他的错误
  }
}

这将产生以下结果:

MyException caught
C++ Exception

在这里,what() 是异常类提供的一个公共方法,它已被所有子异常类重载。这将返回异常产生的原因。

由JSRUN为你提供的C++在线运行、在线编译工具
        JSRUN提供的C++在线运行,C++ 在线运行工具,基于linux操作系统环境提供线上编译和线上运行,具有运行快速,运行结果与常用开发、生产环境保持一致的特点。

title

使用此草稿 删除草稿

  • 00:23
注册登录后可减少验证码的弹出,点击前往 注册 | 登录

皮肤:

运行模式:

嵌入代码 iframe嵌入:


服务器已安装大部分常用的第依赖库,但仍可能存在一些未被安装的库, 可以通过本窗口立即安装所需依赖库。


请输入依赖库的名称:

请选择语言: